// 
// (c) Proteus

#include<stdio.h>
#include<stdlib.h>


#define LIMIT 1000

//!  
class Heap{
	int size;					//!<  
	int array[LIMIT];			//!<  
	void Swap(int i1,int i2);	//!<     
public:
	Heap() {size=0;}
	bool Insert(int v);					//!<   
	int Get();							//!<   
	//!    
	bool isEmpty() 	{return !size;}
	bool Merge(Heap*,Heap*);			//!<   
	bool Merge(Heap*);				
};


void Heap::Swap(int i1,int i2)
{
	int t;
	t=array[i1];
	array[i1]=array[i2];
	array[i2]=t;
}

//! \result true   
bool Heap::Insert(int v)
{
	int up,down;
	if(size>=LIMIT) return true;
	array[size]=v; down=size++;
	while(down) {
		up=(down-1)/2;
		if(array[up]>array[down]) Swap(up,down);
		down=up; 
	}
	return false;
}

int Heap::Get()
{
	int up,down,v;
	if(isEmpty()) return -1;
	v=array[0]; size--; array[0]=array[size];
	up=0;
	for(;;) {
		down=up*2+1;
		if(down>=size) break;
		if(down+1<size && array[down+1]<=array[down]) down++;
		if(array[up]<=array[down]) break;
		Swap(up,down);
		up=down;
	}
	return v;
}

// .    ,   .
//     
//           
// (        ,    )
// C              
//       ,
// ..  =D*ln(D),  D -    
bool Heap::Merge(Heap *obj1,Heap *obj2)
{
	if(obj1->size+obj2->size>LIMIT) return true;
	for(int n=0;n<obj1->size && n<obj2->size;n++) Insert(obj1->array[n]),Insert(obj2->array[n]);
	while(n<obj1->size) Insert(obj1->array[n++]);
	while(n<obj2->size) Insert(obj2->array[n++]);
	return false;
}

//    
bool Heap::Merge(Heap *obj)
{
	if(size*obj->size>LIMIT) return true;
	for(int n=0; n<obj->size; n++) Insert(obj->array[n]);
	return false;
}


//-----

//  
void simple_test()
{
	Heap heap;
	while(!heap.Insert(rand()%30));
	while(!heap.isEmpty()) printf("[%d]",heap.Get());
	putchar('\n');
}

//   
void merge_test()
{
	int n;
	Heap heap,heap1,heap2;
	for(n=rand()%30; n<LIMIT/2; n++) heap1.Insert(rand()%30);
	for(n=rand()%30; n<LIMIT/2; n++) heap2.Insert(rand()%30);
	heap.Merge(&heap1,&heap2);
}	


void main()
{
	simple_test();
}

